"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function get(input, callback, defaultValue) {
    let currentValue = input;
    const handlers = {
        get(value, key) {
            currentValue = value[key];
            if (currentValue && typeof currentValue === 'object') {
                return new Proxy(currentValue, handlers);
            }
            return new Proxy({}, handlers);
        },
    };
    const proxy = new Proxy(input, handlers);
    callback(proxy);
    if (typeof currentValue === 'undefined' || currentValue === null) {
        if (typeof defaultValue !== 'undefined') {
            return defaultValue;
        }
    }
    return currentValue;
}
exports.get = get;
//# sourceMappingURL=get.js.map