"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
function update(input, callback, updater) {
    const keys = [];
    let currentValue = input;
    const handlers = {
        get(value, key) {
            keys.push(key);
            currentValue = value[key];
            if (currentValue && typeof currentValue === 'object') {
                return new Proxy(currentValue, handlers);
            }
            return new Proxy({}, handlers);
        },
    };
    const proxy = new Proxy(input, handlers);
    callback(proxy);
    return utils_1.setIn(input, keys, updater(currentValue));
}
exports.update = update;
//# sourceMappingURL=update.js.map